import{s as Un,o as Rn,n as Yn}from"../chunks/scheduler.9bc65507.js";import{S as Jn,i as Kn,g as r,s as n,r as l,A as Xn,h as a,f as s,c as o,j as _,u as m,x as g,k as b,y as t,a as v,v as c,d as u,t as p,w as f}from"../chunks/index.707bf1b6.js";import{T as Zn}from"../chunks/Tip.c2ecdbf4.js";import{D as y}from"../chunks/Docstring.17db21ae.js";import{H as Ke}from"../chunks/Heading.342b1fa6.js";function eo(Xe){let q,R='Learn how to quantize models in the <a href="../quantization">Quantization</a> guide.';return{c(){q=r("p"),q.innerHTML=R},l(w){q=a(w,"P",{"data-svelte-h":!0}),g(q)!=="svelte-1pv1tva"&&(q.innerHTML=R)},m(w,xe){v(w,q,xe)},p:Yn,d(w){w&&s(q)}}}function to(Xe){let q,R,w,xe,Y,Ze,J,yn="Quantization techniques reduces memory and computational costs by representing weights and activations with lower-precision data types like 8-bit integers (int8). This enables loading larger models you normally wouldn’t be able to fit into memory, and speeding up inference. Transformers supports the AWQ and GPTQ quantization algorithms and it supports 8-bit and 4-bit quantization with bitsandbytes.",et,K,$n="Quantization techniques that aren’t supported in Transformers can be added with the <code>HfQuantizer</code> class.",tt,P,nt,X,ot,T,Z,Lt,we,qn=`This is a wrapper class about all possible attributes and features that you can play with a model that has been
loaded using <code>auto-awq</code> library awq quantization relying on auto_awq backend.`,Qt,L,ee,At,Te,zn="Safety checker that arguments are correct",rt,te,at,x,ne,Mt,Ce,xn=`This is a wrapper class about all possible attributes and features that you can play with a model that has been
loaded using <code>optimum</code> api for gptq quantization relying on auto_gptq backend.`,Ht,Q,oe,Bt,ke,wn="Get compatible class with optimum gptq config dict",Dt,A,re,Gt,Pe,Tn="Safety checker that arguments are correct",Et,M,ae,It,Le,Cn="Get compatible dict for optimum gptq config",st,se,it,$,ie,Ft,Qe,kn=`This is a wrapper class about all possible attributes and features that you can play with a model that has been
loaded using <code>bitsandbytes</code>.`,Vt,Ae,Pn="This replaces <code>load_in_8bit</code> or <code>load_in_4bit</code>therefore both options are mutually exclusive.",Nt,Me,Ln=`Currently only supports <code>LLM.int8()</code>, <code>FP4</code>, and <code>NF4</code> quantization. If more methods are added to <code>bitsandbytes</code>,
then more arguments will be added to this class.`,jt,H,de,Ot,He,Qn="Returns <code>True</code> if the model is quantizable, <code>False</code> otherwise.",Wt,B,le,St,Be,An="Safety checker that arguments are correct - also replaces some NoneType arguments with their default values.",Ut,D,me,Rt,De,Mn=`This method returns the quantization method used for the model. If the model is not quantizable, it returns
<code>None</code>.`,Yt,G,ce,Jt,Ge,Hn=`Removes all attributes from config which correspond to the default config attributes for better readability and
serializes to a Python dictionary.`,dt,ue,lt,d,pe,Kt,Ee,Bn=`Abstract class of the HuggingFace quantizer. Supports for now quantizing HF transformers models for inference and/or quantization.
This class is used only for transformers.PreTrainedModel.from_pretrained and cannot be easily used outside the scope of that method
yet.`,Xt,Ie,Dn=`Attributes
quantization_config (<code>transformers.utils.quantization_config.QuantizationConfigMixin</code>):
The quantization config that defines the quantization parameters of your model that you want to quantize.
modules_to_not_convert (<code>List[str]</code>, <em>optional</em>):
The list of module names to not convert when quantizing the model.
required_packages (<code>List[str]</code>, <em>optional</em>):
The list of required pip packages to install prior to using the quantizer
requires_calibration (<code>bool</code>):
Whether the quantization method requires to calibrate the model before using it.
requires_parameters_quantization (<code>bool</code>):
Whether the quantization method requires to create a new Parameter. For example, for bitsandbytes, it is
required to create a new xxxParameter in order to properly quantize the model.`,Zt,E,fe,en,Fe,Gn="adjust max_memory argument for infer_auto_device_map() if extra memory is needed for quantization",tn,I,ge,nn,Ve,En=`Override this method if you want to adjust the <code>target_dtype</code> variable used in <code>from_pretrained</code>
to compute the device_map in case the device_map is a <code>str</code>. E.g. for bitsandbytes we force-set <code>target_dtype</code>
to <code>torch.int8</code> and for 4-bit we pass a custom enum <code>accelerate.CustomDtype.int4</code>.`,on,F,he,rn,Ne,In=`checks if a loaded state_dict component is part of quantized param + some validation; only defined if
requires_parameters_quantization == True for quantization methods that require to create a new parameters
for quantization.`,an,V,_e,sn,je,Fn=`takes needed components from state_dict and creates quantized param; only applicable if
requires_parameters_quantization == True`,dn,N,be,ln,Oe,Vn=`returns dtypes for modules that are not quantized - used for the computation of the device_map in case
one passes a str as a device_map. The method will use the <code>modules_to_not_convert</code> that is modified
in <code>_process_model_before_weight_loading</code>.`,mn,j,ve,cn,We,Nn=`Post-process the model post weights loading.
Make sure to override the abstract method <code>_process_model_after_weight_loading</code>.`,un,O,ye,pn,Se,jn=`Setting model attributes and/or converting model before weights loading. At this point
the model should be initialized on the meta device so you can freely manipulate the skeleton
of the model in order to replace modules in-place. Make sure to override the abstract method <code>_process_model_before_weight_loading</code>.`,fn,W,$e,gn,Ue,On=`Override this method if you want to pass a override the existing device map with a new
one. E.g. for bitsandbytes, since <code>accelerate</code> is a hard requirement, if no device_map is
passed, the device_map is set to \`“auto”“`,hn,S,qe,_n,Re,Wn=`Some quantization methods require to explicitly set the dtype of the model to a
target dtype. You need to override this method in case you want to make sure that behavior is
preserved`,bn,U,ze,vn,Ye,Sn=`This method is used to potentially check for potential conflicts with arguments that are
passed in <code>from_pretrained</code>. You need to define it for all future quantizers that are integrated with transformers.
If no explicit check are needed, simply return nothing.`,mt,Je,ct;return Y=new Ke({props:{title:"Quantization",local:"quantization",headingTag:"h1"}}),P=new Zn({props:{$$slots:{default:[eo]},$$scope:{ctx:Xe}}}),X=new Ke({props:{title:"AwqConfig",local:"transformers.AwqConfig",headingTag:"h2"}}),Z=new y({props:{name:"class transformers.AwqConfig",anchor:"transformers.AwqConfig",parameters:[{name:"bits",val:": int = 4"},{name:"group_size",val:": int = 128"},{name:"zero_point",val:": bool = True"},{name:"version",val:": AWQLinearVersion = <AWQLinearVersion.GEMM: 'gemm'>"},{name:"backend",val:": AwqBackendPackingMethod = <AwqBackendPackingMethod.AUTOAWQ: 'autoawq'>"},{name:"do_fuse",val:": Optional = None"},{name:"fuse_max_seq_len",val:": Optional = None"},{name:"modules_to_fuse",val:": Optional = None"},{name:"modules_to_not_convert",val:": Optional = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.AwqConfig.bits",description:`<strong>bits</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
The number of bits to quantize to.`,name:"bits"},{anchor:"transformers.AwqConfig.group_size",description:`<strong>group_size</strong> (<code>int</code>, <em>optional</em>, defaults to 128) &#x2014;
The group size to use for quantization. Recommended value is 128 and -1 uses per-column quantization.`,name:"group_size"},{anchor:"transformers.AwqConfig.zero_point",description:`<strong>zero_point</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to use zero point quantization.`,name:"zero_point"},{anchor:"transformers.AwqConfig.version",description:`<strong>version</strong> (<code>AWQLinearVersion</code>, <em>optional</em>, defaults to <code>AWQLinearVersion.GEMM</code>) &#x2014;
The version of the quantization algorithm to use. GEMM is better for big batch_size (e.g. &gt;= 8) otherwise,
GEMV is better (e.g. &lt; 8 )`,name:"version"},{anchor:"transformers.AwqConfig.backend",description:`<strong>backend</strong> (<code>AwqBackendPackingMethod</code>, <em>optional</em>, defaults to <code>AwqBackendPackingMethod.AUTOAWQ</code>) &#x2014;
The quantization backend. Some models might be quantized using <code>llm-awq</code> backend. This is useful for users
that quantize their own models using <code>llm-awq</code> library.`,name:"backend"},{anchor:"transformers.AwqConfig.do_fuse",description:`<strong>do_fuse</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to fuse attention and mlp layers together for faster inference`,name:"do_fuse"},{anchor:"transformers.AwqConfig.fuse_max_seq_len",description:`<strong>fuse_max_seq_len</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The Maximum sequence length to generate when using fusing.`,name:"fuse_max_seq_len"},{anchor:"transformers.AwqConfig.modules_to_fuse",description:`<strong>modules_to_fuse</strong> (<code>dict</code>, <em>optional</em>, default to <code>None</code>) &#x2014;
Overwrite the natively supported fusing scheme with the one specified by the users.`,name:"modules_to_fuse"},{anchor:"transformers.AwqConfig.modules_to_not_convert",description:`<strong>modules_to_not_convert</strong> (<code>list</code>, <em>optional</em>, default to <code>None</code>) &#x2014;
The list of modules to not quantize, useful for quantizing models that explicitly require to have
some modules left in their original precision (e.g. Whisper encoder, Llava encoder, Mixtral gate layers).
Note you cannot quantize directly with transformers, please refer to <code>AutoAWQ</code> documentation for quantizing HF models.`,name:"modules_to_not_convert"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/quantization_config.py#L596"}}),ee=new y({props:{name:"post_init",anchor:"transformers.AwqConfig.post_init",parameters:[],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/quantization_config.py#L659"}}),te=new Ke({props:{title:"GPTQConfig",local:"transformers.GPTQConfig",headingTag:"h2"}}),ne=new y({props:{name:"class transformers.GPTQConfig",anchor:"transformers.GPTQConfig",parameters:[{name:"bits",val:": int"},{name:"tokenizer",val:": Any = None"},{name:"dataset",val:": Union = None"},{name:"group_size",val:": int = 128"},{name:"damp_percent",val:": float = 0.1"},{name:"desc_act",val:": bool = False"},{name:"sym",val:": bool = True"},{name:"true_sequential",val:": bool = True"},{name:"use_cuda_fp16",val:": bool = False"},{name:"model_seqlen",val:": Optional = None"},{name:"block_name_to_quantize",val:": Optional = None"},{name:"module_name_preceding_first_block",val:": Optional = None"},{name:"batch_size",val:": int = 1"},{name:"pad_token_id",val:": Optional = None"},{name:"use_exllama",val:": Optional = None"},{name:"max_input_length",val:": Optional = None"},{name:"exllama_config",val:": Optional = None"},{name:"cache_block_outputs",val:": bool = True"},{name:"modules_in_block_to_quantize",val:": Optional = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.GPTQConfig.bits",description:`<strong>bits</strong> (<code>int</code>) &#x2014;
The number of bits to quantize to, supported numbers are (2, 3, 4, 8).`,name:"bits"},{anchor:"transformers.GPTQConfig.tokenizer",description:`<strong>tokenizer</strong> (<code>str</code> or <code>PreTrainedTokenizerBase</code>, <em>optional</em>) &#x2014;
The tokenizer used to process the dataset. You can pass either:<ul>
<li>A custom tokenizer object.</li>
<li>A string, the <em>model id</em> of a predefined tokenizer hosted inside a model repo on huggingface.co.
Valid model ids can be located at the root-level, like <code>bert-base-uncased</code>, or namespaced under a
user or organization name, like <code>dbmdz/bert-base-german-cased</code>.</li>
<li>A path to a <em>directory</em> containing vocabulary files required by the tokenizer, for instance saved
using the <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.save_pretrained">save_pretrained()</a> method, e.g., <code>./my_model_directory/</code>.</li>
</ul>`,name:"tokenizer"},{anchor:"transformers.GPTQConfig.dataset",description:`<strong>dataset</strong> (<code>Union[List[str]]</code>, <em>optional</em>) &#x2014;
The dataset used for quantization. You can provide your own dataset in a list of string or just use the
original datasets used in GPTQ paper [&#x2018;wikitext2&#x2019;,&#x2018;c4&#x2019;,&#x2018;c4-new&#x2019;,&#x2018;ptb&#x2019;,&#x2018;ptb-new&#x2019;]`,name:"dataset"},{anchor:"transformers.GPTQConfig.group_size",description:`<strong>group_size</strong> (<code>int</code>, <em>optional</em>, defaults to 128) &#x2014;
The group size to use for quantization. Recommended value is 128 and -1 uses per-column quantization.`,name:"group_size"},{anchor:"transformers.GPTQConfig.damp_percent",description:`<strong>damp_percent</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The percent of the average Hessian diagonal to use for dampening. Recommended value is 0.1.`,name:"damp_percent"},{anchor:"transformers.GPTQConfig.desc_act",description:`<strong>desc_act</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to quantize columns in order of decreasing activation size. Setting it to False can significantly
speed up inference but the perplexity may become slightly worse. Also known as act-order.`,name:"desc_act"},{anchor:"transformers.GPTQConfig.sym",description:`<strong>sym</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to use symetric quantization.`,name:"sym"},{anchor:"transformers.GPTQConfig.true_sequential",description:`<strong>true_sequential</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to perform sequential quantization even within a single Transformer block. Instead of quantizing
the entire block at once, we perform layer-wise quantization. As a result, each layer undergoes
quantization using inputs that have passed through the previously quantized layers.`,name:"true_sequential"},{anchor:"transformers.GPTQConfig.use_cuda_fp16",description:`<strong>use_cuda_fp16</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use optimized cuda kernel for fp16 model. Need to have model in fp16.`,name:"use_cuda_fp16"},{anchor:"transformers.GPTQConfig.model_seqlen",description:`<strong>model_seqlen</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The maximum sequence length that the model can take.`,name:"model_seqlen"},{anchor:"transformers.GPTQConfig.block_name_to_quantize",description:`<strong>block_name_to_quantize</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The transformers block name to quantize. If None, we will infer the block name using common patterns (e.g. model.layers)`,name:"block_name_to_quantize"},{anchor:"transformers.GPTQConfig.module_name_preceding_first_block",description:`<strong>module_name_preceding_first_block</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
The layers that are preceding the first Transformer block.`,name:"module_name_preceding_first_block"},{anchor:"transformers.GPTQConfig.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The batch size used when processing the dataset`,name:"batch_size"},{anchor:"transformers.GPTQConfig.pad_token_id",description:`<strong>pad_token_id</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The pad token id. Needed to prepare the dataset when <code>batch_size</code> &gt; 1.`,name:"pad_token_id"},{anchor:"transformers.GPTQConfig.use_exllama",description:`<strong>use_exllama</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to use exllama backend. Defaults to <code>True</code> if unset. Only works with <code>bits</code> = 4.`,name:"use_exllama"},{anchor:"transformers.GPTQConfig.max_input_length",description:`<strong>max_input_length</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The maximum input length. This is needed to initialize a buffer that depends on the maximum expected input
length. It is specific to the exllama backend with act-order.`,name:"max_input_length"},{anchor:"transformers.GPTQConfig.exllama_config",description:`<strong>exllama_config</strong> (<code>Dict[str, Any]</code>, <em>optional</em>) &#x2014;
The exllama config. You can specify the version of the exllama kernel through the <code>version</code> key. Defaults
to <code>{&quot;version&quot;: 1}</code> if unset.`,name:"exllama_config"},{anchor:"transformers.GPTQConfig.cache_block_outputs",description:`<strong>cache_block_outputs</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to cache block outputs to reuse as inputs for the succeeding block.`,name:"cache_block_outputs"},{anchor:"transformers.GPTQConfig.modules_in_block_to_quantize",description:`<strong>modules_in_block_to_quantize</strong> (<code>List[List[str]]</code>, <em>optional</em>) &#x2014;
List of list of module names to quantize in the specified block. This argument is useful to exclude certain linear modules from being quantized.
The block to quantize can be specified by setting <code>block_name_to_quantize</code>. We will quantize each list sequentially. If not set, we will quantize all linear layers.
Example: <code>modules_in_block_to_quantize =[[&quot;self_attn.k_proj&quot;, &quot;self_attn.v_proj&quot;, &quot;self_attn.q_proj&quot;], [&quot;self_attn.o_proj&quot;]]</code>.
In this example, we will first quantize the q,k,v layers simultaneously since they are independent.
Then, we will quantize <code>self_attn.o_proj</code> layer with the q,k,v layers quantized. This way, we will get
better results since it reflects the real input <code>self_attn.o_proj</code> will get when the model is quantized.`,name:"modules_in_block_to_quantize"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/quantization_config.py#L382"}}),oe=new y({props:{name:"from_dict_optimum",anchor:"transformers.GPTQConfig.from_dict_optimum",parameters:[{name:"config_dict",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/quantization_config.py#L581"}}),re=new y({props:{name:"post_init",anchor:"transformers.GPTQConfig.post_init",parameters:[],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/quantization_config.py#L498"}}),ae=new y({props:{name:"to_dict_optimum",anchor:"transformers.GPTQConfig.to_dict_optimum",parameters:[],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/quantization_config.py#L572"}}),se=new Ke({props:{title:"BitsAndBytesConfig",local:"transformers.BitsAndBytesConfig",headingTag:"h2"}}),ie=new y({props:{name:"class transformers.BitsAndBytesConfig",anchor:"transformers.BitsAndBytesConfig",parameters:[{name:"load_in_8bit",val:" = False"},{name:"load_in_4bit",val:" = False"},{name:"llm_int8_threshold",val:" = 6.0"},{name:"llm_int8_skip_modules",val:" = None"},{name:"llm_int8_enable_fp32_cpu_offload",val:" = False"},{name:"llm_int8_has_fp16_weight",val:" = False"},{name:"bnb_4bit_compute_dtype",val:" = None"},{name:"bnb_4bit_quant_type",val:" = 'fp4'"},{name:"bnb_4bit_use_double_quant",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.BitsAndBytesConfig.load_in_8bit",description:`<strong>load_in_8bit</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
This flag is used to enable 8-bit quantization with LLM.int8().`,name:"load_in_8bit"},{anchor:"transformers.BitsAndBytesConfig.load_in_4bit",description:`<strong>load_in_4bit</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
This flag is used to enable 4-bit quantization by replacing the Linear layers with FP4/NF4 layers from
<code>bitsandbytes</code>.`,name:"load_in_4bit"},{anchor:"transformers.BitsAndBytesConfig.llm_int8_threshold",description:`<strong>llm_int8_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 6.0) &#x2014;
This corresponds to the outlier threshold for outlier detection as described in <code>LLM.int8() : 8-bit Matrix Multiplication for Transformers at Scale</code> paper: <a href="https://arxiv.org/abs/2208.07339" rel="nofollow">https://arxiv.org/abs/2208.07339</a> Any hidden states value
that is above this threshold will be considered an outlier and the operation on those values will be done
in fp16. Values are usually normally distributed, that is, most values are in the range [-3.5, 3.5], but
there are some exceptional systematic outliers that are very differently distributed for large models.
These outliers are often in the interval [-60, -6] or [6, 60]. Int8 quantization works well for values of
magnitude ~5, but beyond that, there is a significant performance penalty. A good default threshold is 6,
but a lower threshold might be needed for more unstable models (small models, fine-tuning).`,name:"llm_int8_threshold"},{anchor:"transformers.BitsAndBytesConfig.llm_int8_skip_modules",description:`<strong>llm_int8_skip_modules</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
An explicit list of the modules that we do not want to convert in 8-bit. This is useful for models such as
Jukebox that has several heads in different places and not necessarily at the last position. For example
for <code>CausalLM</code> models, the last <code>lm_head</code> is kept in its original <code>dtype</code>.`,name:"llm_int8_skip_modules"},{anchor:"transformers.BitsAndBytesConfig.llm_int8_enable_fp32_cpu_offload",description:`<strong>llm_int8_enable_fp32_cpu_offload</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
This flag is used for advanced use cases and users that are aware of this feature. If you want to split
your model in different parts and run some parts in int8 on GPU and some parts in fp32 on CPU, you can use
this flag. This is useful for offloading large models such as <code>google/flan-t5-xxl</code>. Note that the int8
operations will not be run on CPU.`,name:"llm_int8_enable_fp32_cpu_offload"},{anchor:"transformers.BitsAndBytesConfig.llm_int8_has_fp16_weight",description:`<strong>llm_int8_has_fp16_weight</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
This flag runs LLM.int8() with 16-bit main weights. This is useful for fine-tuning as the weights do not
have to be converted back and forth for the backward pass.`,name:"llm_int8_has_fp16_weight"},{anchor:"transformers.BitsAndBytesConfig.bnb_4bit_compute_dtype",description:`<strong>bnb_4bit_compute_dtype</strong> (<code>torch.dtype</code> or str, <em>optional</em>, defaults to <code>torch.float32</code>) &#x2014;
This sets the computational type which might be different than the input time. For example, inputs might be
fp32, but computation can be set to bf16 for speedups.`,name:"bnb_4bit_compute_dtype"},{anchor:"transformers.BitsAndBytesConfig.bnb_4bit_quant_type",description:`<strong>bnb_4bit_quant_type</strong> (<code>str</code>,  <em>optional</em>, defaults to <code>&quot;fp4&quot;</code>) &#x2014;
This sets the quantization data type in the bnb.nn.Linear4Bit layers. Options are FP4 and NF4 data types
which are specified by <code>fp4</code> or <code>nf4</code>.`,name:"bnb_4bit_quant_type"},{anchor:"transformers.BitsAndBytesConfig.bnb_4bit_use_double_quant",description:`<strong>bnb_4bit_use_double_quant</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
This flag is used for nested quantization where the quantization constants from the first quantization are
quantized again.`,name:"bnb_4bit_use_double_quant"},{anchor:"transformers.BitsAndBytesConfig.kwargs",description:`<strong>kwargs</strong> (<code>Dict[str, Any]</code>, <em>optional</em>) &#x2014;
Additional parameters from which to initialize the configuration object.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/quantization_config.py#L178"}}),de=new y({props:{name:"is_quantizable",anchor:"transformers.BitsAndBytesConfig.is_quantizable",parameters:[],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/quantization_config.py#L318"}}),le=new y({props:{name:"post_init",anchor:"transformers.BitsAndBytesConfig.post_init",parameters:[],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/quantization_config.py#L287"}}),me=new y({props:{name:"quantization_method",anchor:"transformers.BitsAndBytesConfig.quantization_method",parameters:[],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/quantization_config.py#L324"}}),ce=new y({props:{name:"to_diff_dict",anchor:"transformers.BitsAndBytesConfig.to_diff_dict",parameters:[],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/quantization_config.py#L354",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Dictionary of all the attributes that make up this configuration instance,</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>Dict[str, Any]</code></p>
`}}),ue=new Ke({props:{title:"HfQuantizer",local:"transformers.quantizers.HfQuantizer",headingTag:"h2"}}),pe=new y({props:{name:"class transformers.quantizers.HfQuantizer",anchor:"transformers.quantizers.HfQuantizer",parameters:[{name:"quantization_config",val:": QuantizationConfigMixin"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/quantizers/base.py#L28"}}),fe=new y({props:{name:"adjust_max_memory",anchor:"transformers.quantizers.HfQuantizer.adjust_max_memory",parameters:[{name:"max_memory",val:": Dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/quantizers/base.py#L120"}}),ge=new y({props:{name:"adjust_target_dtype",anchor:"transformers.quantizers.HfQuantizer.adjust_target_dtype",parameters:[{name:"torch_dtype",val:": torch.dtype"}],parametersDescription:[{anchor:"transformers.quantizers.HfQuantizer.adjust_target_dtype.torch_dtype",description:`<strong>torch_dtype</strong> (<code>torch.dtype</code>, <em>optional</em>) &#x2014;
The torch_dtype that is used to compute the device_map.`,name:"torch_dtype"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/quantizers/base.py#L90"}}),he=new y({props:{name:"check_quantized_param",anchor:"transformers.quantizers.HfQuantizer.check_quantized_param",parameters:[{name:"model",val:": PreTrainedModel"},{name:"param_value",val:": torch.Tensor"},{name:"param_name",val:": str"},{name:"state_dict",val:": Dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/quantizers/base.py#L124"}}),_e=new y({props:{name:"create_quantized_param",anchor:"transformers.quantizers.HfQuantizer.create_quantized_param",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/quantizers/base.py#L134"}}),be=new y({props:{name:"get_special_dtypes_update",anchor:"transformers.quantizers.HfQuantizer.get_special_dtypes_update",parameters:[{name:"model",val:""},{name:"torch_dtype",val:": torch.dtype"}],parametersDescription:[{anchor:"transformers.quantizers.HfQuantizer.get_special_dtypes_update.model",description:`<strong>model</strong> (<code>~transformers.PreTrainedModel</code>) &#x2014;
The model to quantize`,name:"model"},{anchor:"transformers.quantizers.HfQuantizer.get_special_dtypes_update.torch_dtype",description:`<strong>torch_dtype</strong> (<code>torch.dtype</code>) &#x2014;
The dtype passed in <code>from_pretrained</code> method.`,name:"torch_dtype"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/quantizers/base.py#L102"}}),ve=new y({props:{name:"postprocess_model",anchor:"transformers.quantizers.HfQuantizer.postprocess_model",parameters:[{name:"model",val:": PreTrainedModel"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.quantizers.HfQuantizer.postprocess_model.model",description:`<strong>model</strong> (<code>~transformers.PreTrainedModel</code>) &#x2014;
The model to quantize`,name:"model"},{anchor:"transformers.quantizers.HfQuantizer.postprocess_model.kwargs",description:`<strong>kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
The keyword arguments that are passed along <code>_process_model_after_weight_loading</code>.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/quantizers/base.py#L168"}}),ye=new y({props:{name:"preprocess_model",anchor:"transformers.quantizers.HfQuantizer.preprocess_model",parameters:[{name:"model",val:": PreTrainedModel"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.quantizers.HfQuantizer.preprocess_model.model",description:`<strong>model</strong> (<code>~transformers.PreTrainedModel</code>) &#x2014;
The model to quantize`,name:"model"},{anchor:"transformers.quantizers.HfQuantizer.preprocess_model.kwargs",description:`<strong>kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
The keyword arguments that are passed along <code>_process_model_before_weight_loading</code>.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/quantizers/base.py#L152"}}),$e=new y({props:{name:"update_device_map",anchor:"transformers.quantizers.HfQuantizer.update_device_map",parameters:[{name:"device_map",val:": Optional"}],parametersDescription:[{anchor:"transformers.quantizers.HfQuantizer.update_device_map.device_map",description:`<strong>device_map</strong> (<code>Union[dict, str]</code>, <em>optional</em>) &#x2014;
The device_map that is passed through the <code>from_pretrained</code> method.`,name:"device_map"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/quantizers/base.py#L78"}}),qe=new y({props:{name:"update_torch_dtype",anchor:"transformers.quantizers.HfQuantizer.update_torch_dtype",parameters:[{name:"torch_dtype",val:": torch.dtype"}],parametersDescription:[{anchor:"transformers.quantizers.HfQuantizer.update_torch_dtype.torch_dtype",description:`<strong>torch_dtype</strong> (<code>torch.dtype</code>) &#x2014;
The input dtype that is passed in <code>from_pretrained</code>`,name:"torch_dtype"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/quantizers/base.py#L66"}}),ze=new y({props:{name:"validate_environment",anchor:"transformers.quantizers.HfQuantizer.validate_environment",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/quantizers/base.py#L144"}}),{c(){q=r("meta"),R=n(),w=r("p"),xe=n(),l(Y.$$.fragment),Ze=n(),J=r("p"),J.textContent=yn,et=n(),K=r("p"),K.innerHTML=$n,tt=n(),l(P.$$.fragment),nt=n(),l(X.$$.fragment),ot=n(),T=r("div"),l(Z.$$.fragment),Lt=n(),we=r("p"),we.innerHTML=qn,Qt=n(),L=r("div"),l(ee.$$.fragment),At=n(),Te=r("p"),Te.textContent=zn,rt=n(),l(te.$$.fragment),at=n(),x=r("div"),l(ne.$$.fragment),Mt=n(),Ce=r("p"),Ce.innerHTML=xn,Ht=n(),Q=r("div"),l(oe.$$.fragment),Bt=n(),ke=r("p"),ke.textContent=wn,Dt=n(),A=r("div"),l(re.$$.fragment),Gt=n(),Pe=r("p"),Pe.textContent=Tn,Et=n(),M=r("div"),l(ae.$$.fragment),It=n(),Le=r("p"),Le.textContent=Cn,st=n(),l(se.$$.fragment),it=n(),$=r("div"),l(ie.$$.fragment),Ft=n(),Qe=r("p"),Qe.innerHTML=kn,Vt=n(),Ae=r("p"),Ae.innerHTML=Pn,Nt=n(),Me=r("p"),Me.innerHTML=Ln,jt=n(),H=r("div"),l(de.$$.fragment),Ot=n(),He=r("p"),He.innerHTML=Qn,Wt=n(),B=r("div"),l(le.$$.fragment),St=n(),Be=r("p"),Be.textContent=An,Ut=n(),D=r("div"),l(me.$$.fragment),Rt=n(),De=r("p"),De.innerHTML=Mn,Yt=n(),G=r("div"),l(ce.$$.fragment),Jt=n(),Ge=r("p"),Ge.textContent=Hn,dt=n(),l(ue.$$.fragment),lt=n(),d=r("div"),l(pe.$$.fragment),Kt=n(),Ee=r("p"),Ee.textContent=Bn,Xt=n(),Ie=r("p"),Ie.innerHTML=Dn,Zt=n(),E=r("div"),l(fe.$$.fragment),en=n(),Fe=r("p"),Fe.textContent=Gn,tn=n(),I=r("div"),l(ge.$$.fragment),nn=n(),Ve=r("p"),Ve.innerHTML=En,on=n(),F=r("div"),l(he.$$.fragment),rn=n(),Ne=r("p"),Ne.textContent=In,an=n(),V=r("div"),l(_e.$$.fragment),sn=n(),je=r("p"),je.textContent=Fn,dn=n(),N=r("div"),l(be.$$.fragment),ln=n(),Oe=r("p"),Oe.innerHTML=Vn,mn=n(),j=r("div"),l(ve.$$.fragment),cn=n(),We=r("p"),We.innerHTML=Nn,un=n(),O=r("div"),l(ye.$$.fragment),pn=n(),Se=r("p"),Se.innerHTML=jn,fn=n(),W=r("div"),l($e.$$.fragment),gn=n(),Ue=r("p"),Ue.innerHTML=On,hn=n(),S=r("div"),l(qe.$$.fragment),_n=n(),Re=r("p"),Re.textContent=Wn,bn=n(),U=r("div"),l(ze.$$.fragment),vn=n(),Ye=r("p"),Ye.innerHTML=Sn,mt=n(),Je=r("p"),this.h()},l(e){const i=Xn("svelte-u9bgzb",document.head);q=a(i,"META",{name:!0,content:!0}),i.forEach(s),R=o(e),w=a(e,"P",{}),_(w).forEach(s),xe=o(e),m(Y.$$.fragment,e),Ze=o(e),J=a(e,"P",{"data-svelte-h":!0}),g(J)!=="svelte-1m63e94"&&(J.textContent=yn),et=o(e),K=a(e,"P",{"data-svelte-h":!0}),g(K)!=="svelte-bnel0f"&&(K.innerHTML=$n),tt=o(e),m(P.$$.fragment,e),nt=o(e),m(X.$$.fragment,e),ot=o(e),T=a(e,"DIV",{class:!0});var k=_(T);m(Z.$$.fragment,k),Lt=o(k),we=a(k,"P",{"data-svelte-h":!0}),g(we)!=="svelte-1i667it"&&(we.innerHTML=qn),Qt=o(k),L=a(k,"DIV",{class:!0});var ut=_(L);m(ee.$$.fragment,ut),At=o(ut),Te=a(ut,"P",{"data-svelte-h":!0}),g(Te)!=="svelte-1ozftb6"&&(Te.textContent=zn),ut.forEach(s),k.forEach(s),rt=o(e),m(te.$$.fragment,e),at=o(e),x=a(e,"DIV",{class:!0});var C=_(x);m(ne.$$.fragment,C),Mt=o(C),Ce=a(C,"P",{"data-svelte-h":!0}),g(Ce)!=="svelte-i3efvr"&&(Ce.innerHTML=xn),Ht=o(C),Q=a(C,"DIV",{class:!0});var pt=_(Q);m(oe.$$.fragment,pt),Bt=o(pt),ke=a(pt,"P",{"data-svelte-h":!0}),g(ke)!=="svelte-4jdj2l"&&(ke.textContent=wn),pt.forEach(s),Dt=o(C),A=a(C,"DIV",{class:!0});var ft=_(A);m(re.$$.fragment,ft),Gt=o(ft),Pe=a(ft,"P",{"data-svelte-h":!0}),g(Pe)!=="svelte-1ozftb6"&&(Pe.textContent=Tn),ft.forEach(s),Et=o(C),M=a(C,"DIV",{class:!0});var gt=_(M);m(ae.$$.fragment,gt),It=o(gt),Le=a(gt,"P",{"data-svelte-h":!0}),g(Le)!=="svelte-pjgtd6"&&(Le.textContent=Cn),gt.forEach(s),C.forEach(s),st=o(e),m(se.$$.fragment,e),it=o(e),$=a(e,"DIV",{class:!0});var z=_($);m(ie.$$.fragment,z),Ft=o(z),Qe=a(z,"P",{"data-svelte-h":!0}),g(Qe)!=="svelte-woamwr"&&(Qe.innerHTML=kn),Vt=o(z),Ae=a(z,"P",{"data-svelte-h":!0}),g(Ae)!=="svelte-ki5gis"&&(Ae.innerHTML=Pn),Nt=o(z),Me=a(z,"P",{"data-svelte-h":!0}),g(Me)!=="svelte-8qsk2q"&&(Me.innerHTML=Ln),jt=o(z),H=a(z,"DIV",{class:!0});var ht=_(H);m(de.$$.fragment,ht),Ot=o(ht),He=a(ht,"P",{"data-svelte-h":!0}),g(He)!=="svelte-10tvzyv"&&(He.innerHTML=Qn),ht.forEach(s),Wt=o(z),B=a(z,"DIV",{class:!0});var _t=_(B);m(le.$$.fragment,_t),St=o(_t),Be=a(_t,"P",{"data-svelte-h":!0}),g(Be)!=="svelte-gy26u4"&&(Be.textContent=An),_t.forEach(s),Ut=o(z),D=a(z,"DIV",{class:!0});var bt=_(D);m(me.$$.fragment,bt),Rt=o(bt),De=a(bt,"P",{"data-svelte-h":!0}),g(De)!=="svelte-19bn0da"&&(De.innerHTML=Mn),bt.forEach(s),Yt=o(z),G=a(z,"DIV",{class:!0});var vt=_(G);m(ce.$$.fragment,vt),Jt=o(vt),Ge=a(vt,"P",{"data-svelte-h":!0}),g(Ge)!=="svelte-1p6bdas"&&(Ge.textContent=Hn),vt.forEach(s),z.forEach(s),dt=o(e),m(ue.$$.fragment,e),lt=o(e),d=a(e,"DIV",{class:!0});var h=_(d);m(pe.$$.fragment,h),Kt=o(h),Ee=a(h,"P",{"data-svelte-h":!0}),g(Ee)!=="svelte-1xvcahi"&&(Ee.textContent=Bn),Xt=o(h),Ie=a(h,"P",{"data-svelte-h":!0}),g(Ie)!=="svelte-twdedh"&&(Ie.innerHTML=Dn),Zt=o(h),E=a(h,"DIV",{class:!0});var yt=_(E);m(fe.$$.fragment,yt),en=o(yt),Fe=a(yt,"P",{"data-svelte-h":!0}),g(Fe)!=="svelte-1d4i4z7"&&(Fe.textContent=Gn),yt.forEach(s),tn=o(h),I=a(h,"DIV",{class:!0});var $t=_(I);m(ge.$$.fragment,$t),nn=o($t),Ve=a($t,"P",{"data-svelte-h":!0}),g(Ve)!=="svelte-4t526i"&&(Ve.innerHTML=En),$t.forEach(s),on=o(h),F=a(h,"DIV",{class:!0});var qt=_(F);m(he.$$.fragment,qt),rn=o(qt),Ne=a(qt,"P",{"data-svelte-h":!0}),g(Ne)!=="svelte-1meey31"&&(Ne.textContent=In),qt.forEach(s),an=o(h),V=a(h,"DIV",{class:!0});var zt=_(V);m(_e.$$.fragment,zt),sn=o(zt),je=a(zt,"P",{"data-svelte-h":!0}),g(je)!=="svelte-1j1vsi1"&&(je.textContent=Fn),zt.forEach(s),dn=o(h),N=a(h,"DIV",{class:!0});var xt=_(N);m(be.$$.fragment,xt),ln=o(xt),Oe=a(xt,"P",{"data-svelte-h":!0}),g(Oe)!=="svelte-i8h8td"&&(Oe.innerHTML=Vn),xt.forEach(s),mn=o(h),j=a(h,"DIV",{class:!0});var wt=_(j);m(ve.$$.fragment,wt),cn=o(wt),We=a(wt,"P",{"data-svelte-h":!0}),g(We)!=="svelte-1uznum5"&&(We.innerHTML=Nn),wt.forEach(s),un=o(h),O=a(h,"DIV",{class:!0});var Tt=_(O);m(ye.$$.fragment,Tt),pn=o(Tt),Se=a(Tt,"P",{"data-svelte-h":!0}),g(Se)!=="svelte-mjhdcv"&&(Se.innerHTML=jn),Tt.forEach(s),fn=o(h),W=a(h,"DIV",{class:!0});var Ct=_(W);m($e.$$.fragment,Ct),gn=o(Ct),Ue=a(Ct,"P",{"data-svelte-h":!0}),g(Ue)!=="svelte-1e5epn5"&&(Ue.innerHTML=On),Ct.forEach(s),hn=o(h),S=a(h,"DIV",{class:!0});var kt=_(S);m(qe.$$.fragment,kt),_n=o(kt),Re=a(kt,"P",{"data-svelte-h":!0}),g(Re)!=="svelte-1kpdm09"&&(Re.textContent=Wn),kt.forEach(s),bn=o(h),U=a(h,"DIV",{class:!0});var Pt=_(U);m(ze.$$.fragment,Pt),vn=o(Pt),Ye=a(Pt,"P",{"data-svelte-h":!0}),g(Ye)!=="svelte-1lxocan"&&(Ye.innerHTML=Sn),Pt.forEach(s),h.forEach(s),mt=o(e),Je=a(e,"P",{}),_(Je).forEach(s),this.h()},h(){b(q,"name","hf:doc:metadata"),b(q,"content",no),b(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),b(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,i){t(document.head,q),v(e,R,i),v(e,w,i),v(e,xe,i),c(Y,e,i),v(e,Ze,i),v(e,J,i),v(e,et,i),v(e,K,i),v(e,tt,i),c(P,e,i),v(e,nt,i),c(X,e,i),v(e,ot,i),v(e,T,i),c(Z,T,null),t(T,Lt),t(T,we),t(T,Qt),t(T,L),c(ee,L,null),t(L,At),t(L,Te),v(e,rt,i),c(te,e,i),v(e,at,i),v(e,x,i),c(ne,x,null),t(x,Mt),t(x,Ce),t(x,Ht),t(x,Q),c(oe,Q,null),t(Q,Bt),t(Q,ke),t(x,Dt),t(x,A),c(re,A,null),t(A,Gt),t(A,Pe),t(x,Et),t(x,M),c(ae,M,null),t(M,It),t(M,Le),v(e,st,i),c(se,e,i),v(e,it,i),v(e,$,i),c(ie,$,null),t($,Ft),t($,Qe),t($,Vt),t($,Ae),t($,Nt),t($,Me),t($,jt),t($,H),c(de,H,null),t(H,Ot),t(H,He),t($,Wt),t($,B),c(le,B,null),t(B,St),t(B,Be),t($,Ut),t($,D),c(me,D,null),t(D,Rt),t(D,De),t($,Yt),t($,G),c(ce,G,null),t(G,Jt),t(G,Ge),v(e,dt,i),c(ue,e,i),v(e,lt,i),v(e,d,i),c(pe,d,null),t(d,Kt),t(d,Ee),t(d,Xt),t(d,Ie),t(d,Zt),t(d,E),c(fe,E,null),t(E,en),t(E,Fe),t(d,tn),t(d,I),c(ge,I,null),t(I,nn),t(I,Ve),t(d,on),t(d,F),c(he,F,null),t(F,rn),t(F,Ne),t(d,an),t(d,V),c(_e,V,null),t(V,sn),t(V,je),t(d,dn),t(d,N),c(be,N,null),t(N,ln),t(N,Oe),t(d,mn),t(d,j),c(ve,j,null),t(j,cn),t(j,We),t(d,un),t(d,O),c(ye,O,null),t(O,pn),t(O,Se),t(d,fn),t(d,W),c($e,W,null),t(W,gn),t(W,Ue),t(d,hn),t(d,S),c(qe,S,null),t(S,_n),t(S,Re),t(d,bn),t(d,U),c(ze,U,null),t(U,vn),t(U,Ye),v(e,mt,i),v(e,Je,i),ct=!0},p(e,[i]){const k={};i&2&&(k.$$scope={dirty:i,ctx:e}),P.$set(k)},i(e){ct||(u(Y.$$.fragment,e),u(P.$$.fragment,e),u(X.$$.fragment,e),u(Z.$$.fragment,e),u(ee.$$.fragment,e),u(te.$$.fragment,e),u(ne.$$.fragment,e),u(oe.$$.fragment,e),u(re.$$.fragment,e),u(ae.$$.fragment,e),u(se.$$.fragment,e),u(ie.$$.fragment,e),u(de.$$.fragment,e),u(le.$$.fragment,e),u(me.$$.fragment,e),u(ce.$$.fragment,e),u(ue.$$.fragment,e),u(pe.$$.fragment,e),u(fe.$$.fragment,e),u(ge.$$.fragment,e),u(he.$$.fragment,e),u(_e.$$.fragment,e),u(be.$$.fragment,e),u(ve.$$.fragment,e),u(ye.$$.fragment,e),u($e.$$.fragment,e),u(qe.$$.fragment,e),u(ze.$$.fragment,e),ct=!0)},o(e){p(Y.$$.fragment,e),p(P.$$.fragment,e),p(X.$$.fragment,e),p(Z.$$.fragment,e),p(ee.$$.fragment,e),p(te.$$.fragment,e),p(ne.$$.fragment,e),p(oe.$$.fragment,e),p(re.$$.fragment,e),p(ae.$$.fragment,e),p(se.$$.fragment,e),p(ie.$$.fragment,e),p(de.$$.fragment,e),p(le.$$.fragment,e),p(me.$$.fragment,e),p(ce.$$.fragment,e),p(ue.$$.fragment,e),p(pe.$$.fragment,e),p(fe.$$.fragment,e),p(ge.$$.fragment,e),p(he.$$.fragment,e),p(_e.$$.fragment,e),p(be.$$.fragment,e),p(ve.$$.fragment,e),p(ye.$$.fragment,e),p($e.$$.fragment,e),p(qe.$$.fragment,e),p(ze.$$.fragment,e),ct=!1},d(e){e&&(s(R),s(w),s(xe),s(Ze),s(J),s(et),s(K),s(tt),s(nt),s(ot),s(T),s(rt),s(at),s(x),s(st),s(it),s($),s(dt),s(lt),s(d),s(mt),s(Je)),s(q),f(Y,e),f(P,e),f(X,e),f(Z),f(ee),f(te,e),f(ne),f(oe),f(re),f(ae),f(se,e),f(ie),f(de),f(le),f(me),f(ce),f(ue,e),f(pe),f(fe),f(ge),f(he),f(_e),f(be),f(ve),f(ye),f($e),f(qe),f(ze)}}}const no='{"title":"Quantization","local":"quantization","sections":[{"title":"AwqConfig","local":"transformers.AwqConfig","sections":[],"depth":2},{"title":"GPTQConfig","local":"transformers.GPTQConfig","sections":[],"depth":2},{"title":"BitsAndBytesConfig","local":"transformers.BitsAndBytesConfig","sections":[],"depth":2},{"title":"HfQuantizer","local":"transformers.quantizers.HfQuantizer","sections":[],"depth":2}],"depth":1}';function oo(Xe){return Rn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class mo extends Jn{constructor(q){super(),Kn(this,q,oo,to,Un,{})}}export{mo as component};
